var internal = {};

function CciWSClient() {

}

CciWSClient.prototype.Configure = function (PanelId, UseSsl, Port) {

    this.listeners = {}
    this.PanelId = PanelId;
    this.wsUri = "";
    this.host = "192.168.193.102"
    //this.host = location.host;

    if (UseSsl)
        this.wsUri = "wss://" + this.host + ":" + Port + "/";
    else
        this.wsUri = "ws://" + this.host + ":" + Port + "/";

    this.websocketclient = new internal.websocketclient(this.wsUri, this.PanelId, this);
}

CciWSClient.prototype.registerDigitalEvent = function (Index, callback) {

    if (isNaN(Index) == false && callback) {

        var name = "Digital:" + Index;

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerAnalogEvent = function (Index, callback) {

    if (isNaN(Index) == false && callback) {
            
        var name = "Analog:" + Index;

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerSignedAnalogEvent = function (Index, callback) {

    if (isNaN(Index) == false && callback) {
        
        var name = "SignedAnalog:" + Index;

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerSerialEvent = function (Index, callback) {

    if (isNaN(Index) == false && callback) {
        
        var name = "Serial:" + Index;

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerOnlineEvent = function (callback) {

    if (callback) {
        
        var name = "Online";

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerOfflineEvent = function (callback) {

    if (callback) {
        
        var name = "Offline";

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}

CciWSClient.prototype.registerOnErrorEvent = function (callback) {

    if (callback) {
        
        var name = "OnError";

        if (!this.listeners[name])
            this.listeners[name] = [];

        this.listeners[name].push(callback);
    }
}


CciWSClient.prototype.setDigital = function (Index, State) {

    if (isNaN(Index) == false && typeof State === "boolean") {

        var msg = {
            Type: "Digital",
            Id: this.PanelId,
            Index: Index,
            Value: State
        }

        this.websocketclient.send(msg);
    }
}

CciWSClient.prototype.setAnalog = function (Index, Value) {

    if (isNaN(Index) == false && Value) {

        var msg = {
            Type: "Analog",
            Id: this.PanelId,
            Index: Index,
            Value: Value
        }

        this.websocketclient.send(msg);
    }
}

CciWSClient.prototype.setSignedAnalog = function (Index, Value) {

    if (isNaN(Index) == false && Value) {

        var msg = {
            Type: "SignedAnalog",
            Id: this.PanelId,
            Index: Index,
            Value: Value
        }

        this.websocketclient.send(msg);
    }
}

CciWSClient.prototype.setSerial = function (Index, Value) {

    if (isNaN(Index) == false && Value) {

        var msg = {
            Type: "Serial",
            Id: this.PanelId,
            Index: Index,
            Value: Value
        }

        this.websocketclient.send(msg);
    }
}

CciWSClient.prototype.notifyDigitalEvent = function (msg) {

    if (msg && msg.Index) {
        var name = "Digital:" + msg.Index;

        if (this.listeners[name]) {
            var stack = this.listeners[name];
            for (var index in stack) {
                stack[index](msg);
            }
        }
    }
}

CciWSClient.prototype.notifyAnalogEvent = function (msg) {

    if (msg && msg.Index) {

        var name = "Analog:" + msg.Index;

        if (this.listeners[name]) {
            var stack = this.listeners[name];
            for (var index in stack) {
                stack[index](msg);
            }
        }
    }
}

CciWSClient.prototype.notifySignedAnalogEvent = function (msg) {

    if (msg && msg.Index) {

        var name = "SignedAnalog:" + msg.Index;

        if (this.listeners[name]) {
            var stack = this.listeners[name];
            for (var index in stack) {
                stack[index](msg);
            }
        }
    }
}

CciWSClient.prototype.notifySerialEvent = function (msg) {

    if (msg && msg.Index) {

        var name = "Serial:" + msg.Index;

        if (this.listeners[name]) {
            var stack = this.listeners[name];
            for (var index in stack) {
                stack[index](msg);
            }
        }
    }
}

CciWSClient.prototype.notifyOnlineEvent = function () {

    var name = "Online";

    if (this.listeners[name]) {
        var stack = this.listeners[name];
        for (var index in stack) {
            stack[index]();
        }
    }
}

CciWSClient.prototype.notifyOfflineEvent = function () {

    var name = "Offline";

    if (this.listeners[name]) {
        var stack = this.listeners[name];
        for (var index in stack) {
            stack[index]();
        }
    }
}

CciWSClient.prototype.notifyOnErrorEvent = function (err) {

    var name = "OnError";

    if (this.listeners[name]) {
        var stack = this.listeners[name];
        for (var index in stack) {
            stack[index](err);
        }
    }
}


internal.websocketclient = function (url, panelId, parent) {

    this.url = url;
    this.panelId = panelId;
    this.reconnectHandle = 0;
    this.parent = parent;

    console.log(parent);

    this.errorMessages = {

        '1000': 'Normal Closure',
        '1001': 'Going Away',
        '1002': 'Protocol Error',
        '1003': 'Unsupported Data',
        '1004': '(For future)',
        '1005': 'No Status Received',
        '1006': 'Abnormal Closure',
        '1007': 'Invalid frame payload data',
        '1008': 'Policy Violation',
        '1009': 'Message too big',
        '1010': 'Missing Extension',
        '1011': 'Internal Error',
        '1012': 'Service Restart',
        '1013': 'Try Again Later',
        '1014': 'Bad Gateway',
        '1015': 'TLS Handshake'
    };

    this.wsInit();
}

internal.websocketclient.prototype.wsInit = function () {

    try {

        this.websocket = new WebSocket(this.url);
        this.websocket.parent = this;
        this.websocket.onopen = function (evt) {

            console.log(evt);

            var msg = {
                Type: "Registration",
                Id: this.parent.panelId
            }

            this.send(JSON.stringify(msg));

            this.parent.online();
        }

        this.websocket.onclose = function (evt) {

            console.log(evt);

            if (evt.code)
            {
                var sCode = evt.code.toString(10);

                if (this.parent.errorMessages[sCode])
                    this.parent.onerror(this.parent.errorMessages[sCode]);
            }

            this.parent.offline();
        }

        this.websocket.onmessage = function (evt) {

            if (this.parent && this.parent.received) {

                this.parent.received(evt.data);
            }
        }

        this.websocket.onerror = function (evt) {

            if (evt.code) {

                var sCode = evt.code.toString(10);

                if (this.parent.errorMessages[sCode])
                    this.parent.onerror(this.parent.errorMessages[sCode]);

                else
                    this.parent.onerror("Unknown Error: " + sCode);
            }
        }
    }
    catch (err) {

        this.onerror(err);
    }
}

internal.websocketclient.prototype.send = function (msg) {

    this.websocket.send(JSON.stringify(msg));
}

internal.websocketclient.prototype.received = function (msgs) {

    var obj = JSON.parse(msgs);
    if (Array.isArray(obj)) {

        for (var index in obj) {

            if (obj[index] && obj[index].Index) {

                if (obj[index].Type === "Digital")
                    this.parent.notifyDigitalEvent(obj[index]);

                else if (obj[index].Type === "Analog")
                    this.parent.notifyAnalogEvent(obj[index]);

                else if (obj[index].Type === "SignedAnalog")
                    this.parent.notifySignedAnalogEvent(obj[index]);

                else if (obj[index].Type === "Serial")
                    this.parent.notifySerialEvent(obj[index]);
            }
        }
    }
}

internal.websocketclient.prototype.online = function () {

    this.parent.notifyOnlineEvent();
}

internal.websocketclient.prototype.onerror = function (err) {

    this.parent.notifyOnErrorEvent(err);
}

internal.websocketclient.prototype.offline = function () {

    this.parent.notifyOfflineEvent();

    this.reconnectHandle = setTimeout(this.onReconnectElapsed, 30000, this);
}

internal.websocketclient.prototype.onReconnectElapsed = function (ws) {

    if (ws)
        ws.wsInit();
}